WordPress 4.7
[autoinstalls/wordpress.git] / wp-admin / network / upgrade.php
index 1a004a2fcdf0fcb04fd548218c1b6c2f84d1e982..5c2d3f990ffda0f4aafbac11c4af7fabe1afd451 100644 (file)
@@ -8,10 +8,7 @@
  */
 
 /** Load WordPress Administration Bootstrap */
-require_once( './admin.php' );
-
-if ( ! is_multisite() )
-       wp_die( __( 'Multisite support is not enabled.' ) );
+require_once( dirname( __FILE__ ) . '/admin.php' );
 
 require_once( ABSPATH . WPINC . '/http.php' );
 
@@ -29,18 +26,17 @@ get_current_screen()->add_help_tab( array(
 
 get_current_screen()->set_help_sidebar(
        '<p><strong>' . __('For more information:') . '</strong></p>' .
-       '<p>' . __('<a href="http://codex.wordpress.org/Network_Admin_Updates_Screen" target="_blank">Documentation on Upgrade Network</a>') . '</p>' .
-       '<p>' . __('<a href="http://wordpress.org/support/" target="_blank">Support Forums</a>') . '</p>'
+       '<p>' . __('<a href="https://codex.wordpress.org/Network_Admin_Updates_Screen">Documentation on Upgrade Network</a>') . '</p>' .
+       '<p>' . __('<a href="https://wordpress.org/support/">Support Forums</a>') . '</p>'
 );
 
-require_once('../admin-header.php');
+require_once( ABSPATH . 'wp-admin/admin-header.php' );
 
 if ( ! current_user_can( 'manage_network' ) )
-       wp_die( __( 'You do not have permission to access this page.' ) );
+       wp_die( __( 'Sorry, you are not allowed to access this page.' ), 403 );
 
 echo '<div class="wrap">';
-screen_icon('tools');
-echo '<h2>' . __( 'Upgrade Network' ) . '</h2>';
+echo '<h1>' . __( 'Upgrade Network' ) . '</h1>';
 
 $action = isset($_GET['action']) ? $_GET['action'] : 'show';
 
@@ -49,31 +45,71 @@ switch ( $action ) {
                $n = ( isset($_GET['n']) ) ? intval($_GET['n']) : 0;
 
                if ( $n < 5 ) {
+                       /**
+                        * @global string $wp_db_version
+                        */
                        global $wp_db_version;
                        update_site_option( 'wpmu_upgrade_site', $wp_db_version );
                }
 
-               $blogs = $wpdb->get_results( "SELECT * FROM {$wpdb->blogs} WHERE site_id = '{$wpdb->siteid}' AND spam = '0' AND deleted = '0' AND archived = '0' ORDER BY registered DESC LIMIT {$n}, 5", ARRAY_A );
-               if ( empty( $blogs ) ) {
+               $site_ids = get_sites( array(
+                       'spam'       => 0,
+                       'deleted'    => 0,
+                       'archived'   => 0,
+                       'network_id' => get_current_network_id(),
+                       'number'     => 5,
+                       'offset'     => $n,
+                       'fields'     => 'ids',
+                       'order'      => 'DESC',
+                       'orderby'    => 'id',
+               ) );
+               if ( empty( $site_ids ) ) {
                        echo '<p>' . __( 'All done!' ) . '</p>';
                        break;
                }
                echo "<ul>";
-               foreach ( (array) $blogs as $details ) {
-                       switch_to_blog( $details['blog_id'] );
+               foreach ( (array) $site_ids as $site_id ) {
+                       switch_to_blog( $site_id );
                        $siteurl = site_url();
                        $upgrade_url = admin_url( 'upgrade.php?step=upgrade_db' );
                        restore_current_blog();
+
                        echo "<li>$siteurl</li>";
-                       $response = wp_remote_get( $upgrade_url, array( 'timeout' => 120, 'httpversion' => '1.1' ) );
-                       if ( is_wp_error( $response ) )
-                               wp_die( sprintf( __( 'Warning! Problem updating %1$s. Your server may not be able to connect to sites running on it. Error message: <em>%2$s</em>' ), $siteurl, $response->get_error_message() ) );
+
+                       $response = wp_remote_get( $upgrade_url, array(
+                               'timeout'     => 120,
+                               'httpversion' => '1.1',
+                               'sslverify'   => false,
+                       ) );
+                       if ( is_wp_error( $response ) ) {
+                               wp_die( sprintf(
+                                       /* translators: 1: site url, 2: server error message */
+                                       __( 'Warning! Problem updating %1$s. Your server may not be able to connect to sites running on it. Error message: %2$s' ),
+                                       $siteurl,
+                                       '<em>' . $response->get_error_message() . '</em>'
+                               ) );
+                       }
+
+                       /**
+                        * Fires after the Multisite DB upgrade for each site is complete.
+                        *
+                        * @since MU
+                        *
+                        * @param array|WP_Error $response The upgrade response array or WP_Error on failure.
+                        */
                        do_action( 'after_mu_upgrade', $response );
-                       do_action( 'wpmu_upgrade_site', $details[ 'blog_id' ] );
+                       /**
+                        * Fires after each site has been upgraded.
+                        *
+                        * @since MU
+                        *
+                        * @param int $site_id The Site ID.
+                        */
+                       do_action( 'wpmu_upgrade_site', $site_id );
                }
                echo "</ul>";
                ?><p><?php _e( 'If your browser doesn&#8217;t start loading the next page automatically, click this link:' ); ?> <a class="button" href="upgrade.php?action=upgrade&amp;n=<?php echo ($n + 5) ?>"><?php _e("Next Sites"); ?></a></p>
-               <script type='text/javascript'>
+               <script type="text/javascript">
                <!--
                function nextpage() {
                        location.href = "upgrade.php?action=upgrade&n=<?php echo ($n + 5) ?>";
@@ -86,17 +122,22 @@ switch ( $action ) {
        default:
                if ( get_site_option( 'wpmu_upgrade_site' ) != $GLOBALS['wp_db_version'] ) :
                ?>
-               <h3><?php _e( 'Database Upgrade Required' ); ?></h3>
+               <h2><?php _e( 'Database Update Required' ); ?></h2>
                <p><?php _e( 'WordPress has been updated! Before we send you on your way, we need to individually upgrade the sites in your network.' ); ?></p>
                <?php endif; ?>
 
-               <p><?php _e( 'The upgrade process may take a little while, so please be patient.' ); ?></p>
-               <p><a class="button" href="upgrade.php?action=upgrade"><?php _e( 'Upgrade Network' ); ?></a></p>
+               <p><?php _e( 'The database update process may take a little while, so please be patient.' ); ?></p>
+               <p><a class="button button-primary" href="upgrade.php?action=upgrade"><?php _e( 'Upgrade Network' ); ?></a></p>
                <?php
+               /**
+                * Fires before the footer on the network upgrade screen.
+                *
+                * @since MU
+                */
                do_action( 'wpmu_upgrade_page' );
        break;
 }
 ?>
 </div>
 
-<?php include('../admin-footer.php'); ?>
+<?php include( ABSPATH . 'wp-admin/admin-footer.php' ); ?>